--- ./src/document.c.orig	2010-11-07 15:59:25.000000000 +0200
+++ ./src/document.c	2010-11-08 20:16:39.000000000 +0200
@@ -34,6 +34,7 @@
 #include <time.h>
 
 #include <unistd.h>
+#include <fcntl.h>
 #include <string.h>
 #include <errno.h>
 
@@ -1724,24 +1725,23 @@
 			G_FILE_CREATE_NONE, NULL, NULL, &error);
 		g_object_unref(fp);
 #else
-		gint err = 0;
-		FILE *fp;
-		gint bytes_written;
+		int fd;
+		gboolean failed = FALSE;
 
 		/* Use POSIX API for unsafe saving (GVFS-unsafe) */
-		fp = g_fopen(locale_filename, "wb");
-		if (G_UNLIKELY(fp == NULL))
-			return g_strdup(g_strerror(errno));
-
-		bytes_written = fwrite(data, sizeof(gchar), len, fp);
-
-		if (G_UNLIKELY(len != bytes_written))
-			err = errno;
-
-		fclose(fp);
+		fd = creat(locale_filename, 0666);
+		if (G_UNLIKELY(fd == -1))
+			failed = TRUE;
+		else
+		{
+			if (write(fd, data, len) != len || fsync(fd))
+				failed = TRUE;
+			if (close(fd))
+				failed = TRUE;
+		}
 
-		if (err != 0)
-			return g_strdup(g_strerror(err));
+		if (failed)
+			return g_strdup(g_strerror(errno));
 #endif
 	}
 	else
